Index: src/pl/plpython/plpython.c
===================================================================
RCS file: /cvsroot/pgsql/src/pl/plpython/plpython.c,v
retrieving revision 1.106
diff -u -3 -p -r1.106 plpython.c
--- src/pl/plpython/plpython.c	2 Jan 2008 03:10:27 -0000	1.106
+++ src/pl/plpython/plpython.c	27 Oct 2009 14:13:00 -0000
@@ -2840,9 +2840,9 @@ PLy_fatal(PyObject * self, PyObject * ar
 static PyObject *
 PLy_output(volatile int level, PyObject * self, PyObject * args)
 {
-	PyObject   *so;
+	PyObject   *volatile so;
 	char	   *volatile sv;
-	MemoryContext oldcontext;
+	volatile MemoryContext oldcontext;
 
 	so = PyObject_Str(args);
 	if (so == NULL || ((sv = PyString_AsString(so)) == NULL))
@@ -2861,6 +2861,10 @@ PLy_output(volatile int level, PyObject 
 		MemoryContextSwitchTo(oldcontext);
 		PLy_error_in_progress = CopyErrorData();
 		FlushErrorState();
+
+		PyErr_SetString(PLy_exc_error, sv);
+		/* Note: If sv came from PyString_AsString(), it points into
+		 * storage owned by so.  So free so after using sv. */
 		Py_XDECREF(so);
 
 		/*
@@ -2868,7 +2872,6 @@ PLy_output(volatile int level, PyObject 
 		 * control passes back to PLy_procedure_call, we check for PG
 		 * exceptions and re-throw the error.
 		 */
-		PyErr_SetString(PLy_exc_error, sv);
 		return NULL;
 	}
 	PG_END_TRY();
